clear all
close all
meshfile=gmsh.buildmesh3d('cylinder3holes',30);
Th=ooMesh(meshfile)
u=@(x,y,z) cos(2*x-y-z).*sin(x-2*y+z);
U=Th.eval(u);
h=figure(1)
set(h,'Position',[0 0 1920 1080],'visible','off')
axis off;axis image
%video = VideoWriter([mfilename(),'.avi']);
%open(video);
mkdir('./videos')
file=mfilename();
saveimage=@(i) print('-dpng','-r600',sprintf('./videos/%s-%s.png',file,intstr(i,5)));

N=10*25;
k=1;
Ltheta=[0:2*pi/N:2*pi]
for theta=Ltheta
  disp(k)
  P=PlaneCoefs([0 0 1],[cos(theta) sin(theta) 1]);
  clf
  axis off;axis image;hold on
  Th.slice(U,P)
  Th.plotVal(U,'d',2,'labels',[100,101])
  caxis([min(U),max(U)])
  isorange=linspace(min(U),max(U),10);
  Th.plot('d',2,'labels',[10,20,21], 'FaceColor','none', 'EdgeColor',0.95*[1,1,1])
  Th.plotIsolines(U,'labels',[100,101],'isorange',isorange,'color','w')
  Th.isoslice(U,P,'isorange',isorange,'Color','w')
  shading interp
  %Th.plot('d',2,'labels',[10,20,21], 'legend',false, 'PlotOptions',{'FaceAlpha',0.1,'FaceColor','none', 'EdgeColor',0.95*[1,1,1]})
  view(-114,11)
  %drawnow
 % writeVideo(video,getframe(gcf));
  saveimage(k)
  k=k+1;
end
% mencoder mf://*.png -mf w=1200:h=900:fps=15:type=png -ovc lavc -lavcopts vcodec=mpeg4:mbd=2:trell -oac copy -o output.avi

% opt="vbitrate=8160000:mbd=2:keyint=132:vqblur=1.0:cmp=2:subcmp=2:dia=2:mv0:last_pred=3"
% mencoder mf://*.png -mf w=1200:h=900:fps=25:type=png  -ovc lavc -lavcopts vcodec=mpeg4:vpass=1:$opt -nosound  -o /dev/null output.avi
%  mencoder mf://*.png -mf w=1200:h=900:fps=25:type=png  -ovc lavc -lavcopts vcodec=mpeg4:vpass=2:$opt -nosound  -o toto.avi output.avi